"""agregado artista

Revision ID: 32f203348854
Revises: 
Create Date: 2021-06-13 15:15:54.928778

"""
from alembic import op
import sqlalchemy as sa

from core.extensions import get_db, get_session , SessionManager

from initial_data.initial_data_user import generate_base_permisions,generate_admin_user,generate_base_albums
# revision identifiers, used by Alembic.
revision = '32f203348854'
down_revision = None
branch_labels = None
depends_on = None

def generate_initial_data(session=get_session()):
    with SessionManager(db_session=session ) as db:

        generate_base_permisions(db=db)
        generate_admin_user(db=db)
        generate_base_albums(db=db)

        db.commit()

def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('tm_artists',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('name', sa.String(length=256), nullable=True),
    sa.Column('start_year', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tm_artists_name'), 'tm_artists', ['name'], unique=True)
    op.create_table('tm_colaborador',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('nombre', sa.String(length=96), nullable=False),
    sa.Column('apellido', sa.String(length=96), nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el colaborador es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.PrimaryKeyConstraint('id'),
    comment='Tabla de datos de colaborador'
    )
    op.create_table('tm_grupo',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('nombre', sa.String(length=96), nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el grupo es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('nombre'),
    comment='Tabla de datos de grupo'
    )
    op.create_table('tm_permiso',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('codigo', sa.String(length=128), nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el permiso es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.PrimaryKeyConstraint('id'),
    comment='Tabla de datos de  permiso'
    )
    op.create_table('ts_tipo_archivo',
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('id', sa.BigInteger(), nullable=False),
    sa.Column('nombre', sa.String(length=128), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('tm_albums',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('name', sa.String(length=128), nullable=True),
    sa.Column('id_artista', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['id_artista'], ['tm_artists.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tm_albums_name'), 'tm_albums', ['name'], unique=True)
    op.create_table('tm_grupo_permiso',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el viceprecidencia es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('id_permiso', sa.Integer(), nullable=True, comment='Id permiso relacionado '),
    sa.Column('id_grupo', sa.Integer(), nullable=True, comment='Id grupo relacionado'),
    sa.ForeignKeyConstraint(['id_grupo'], ['tm_grupo.id'], ),
    sa.ForeignKeyConstraint(['id_permiso'], ['tm_permiso.id'], ),
    sa.PrimaryKeyConstraint('id'),
    comment='Tabla de datos de grupo permiso'
    )
    op.create_table('tm_usuario',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('username', sa.String(length=256), nullable=False),
    sa.Column('correo', sa.String(length=256), nullable=False),
    sa.Column('hash_password', sa.String(length=512), nullable=True),
    sa.Column('estado', sa.String(length=2), nullable=True),
    sa.Column('nro_intentos', sa.Integer(), server_default='0', nullable=True),
    sa.Column('tipo_acceso', sa.Enum('web', 'app', name='acceso'), nullable=True, comment='tipo de acceso del usuario'),
    sa.Column('fecha_acceso', sa.TIMESTAMP(), nullable=False, comment='fecha de ultimo acceso del usuario'),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el usuario es visible para los listados'),
    sa.Column('id_colaborador', sa.Integer(), nullable=True, comment='Id del colaborador para la relacion'),
    sa.Column('apikey', sa.String(length=256), nullable=True),
    sa.ForeignKeyConstraint(['id_colaborador'], ['tm_colaborador.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('username'),
    comment='En esta tabla de usuarios registrados'
    )
    op.create_table('tm_biblioteca',
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('id', sa.BigInteger(), nullable=False),
    sa.Column('nombre', sa.String(length=128), nullable=True),
    sa.Column('ruta', sa.String(length=512), nullable=True),
    sa.Column('id_usuario', sa.Integer(), nullable=False),
    sa.Column('id_tipo_archivo', sa.Integer(), nullable=False),
    sa.Column('id_auxiliar', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['id_tipo_archivo'], ['ts_tipo_archivo.id'], ),
    sa.ForeignKeyConstraint(['id_usuario'], ['tm_usuario.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('tm_songs',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('name', sa.String(length=128), nullable=True),
    sa.Column('album_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['album_id'], ['tm_albums.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tm_songs_album_id'), 'tm_songs', ['album_id'], unique=False)
    op.create_index(op.f('ix_tm_songs_name'), 'tm_songs', ['name'], unique=True)
    op.create_table('tm_usuario_grupo',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el jefatura es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('id_usuario', sa.Integer(), nullable=True, comment='Id de la del usuario relacionado'),
    sa.Column('id_grupo', sa.Integer(), nullable=True, comment='Id del grupo'),
    sa.ForeignKeyConstraint(['id_grupo'], ['tm_grupo.id'], ),
    sa.ForeignKeyConstraint(['id_usuario'], ['tm_usuario.id'], ),
    sa.PrimaryKeyConstraint('id'),
    comment='Tabla de datos de usuario grupo'
    )
    op.create_table('tm_usuario_permiso',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si el usuario_permiso es visible para los listados'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('id_usuario', sa.Integer(), nullable=True, comment='Id de  del usuario relacionado'),
    sa.Column('id_permiso', sa.Integer(), nullable=True, comment='Id del permiso relacionado'),
    sa.ForeignKeyConstraint(['id_permiso'], ['tm_permiso.id'], ),
    sa.ForeignKeyConstraint(['id_usuario'], ['tm_usuario.id'], ),
    sa.PrimaryKeyConstraint('id'),
    comment='Tabla de datos de  usuario_permiso'
    )
    op.create_table('tm_lyrics',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('visible', sa.Boolean(), server_default='1', nullable=False, comment='define si  es visible'),
    sa.Column('activo', sa.Boolean(), server_default='1', nullable=False),
    sa.Column('fecha_registro', sa.TIMESTAMP(), nullable=False, comment='fecha de creacion '),
    sa.Column('fecha_modificacion', sa.TIMESTAMP(), nullable=False, comment='fecha de actualizacion '),
    sa.Column('name', sa.String(length=128), nullable=True),
    sa.Column('text', sa.Text(), nullable=True),
    sa.Column('song_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['song_id'], ['tm_songs.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tm_lyrics_name'), 'tm_lyrics', ['name'], unique=True)
    op.create_index(op.f('ix_tm_lyrics_song_id'), 'tm_lyrics', ['song_id'], unique=False)
    # ### end Alembic commands ###
    generate_initial_data()


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_tm_lyrics_song_id'), table_name='tm_lyrics')
    op.drop_index(op.f('ix_tm_lyrics_name'), table_name='tm_lyrics')
    op.drop_table('tm_lyrics')
    op.drop_table('tm_usuario_permiso')
    op.drop_table('tm_usuario_grupo')
    op.drop_index(op.f('ix_tm_songs_name'), table_name='tm_songs')
    op.drop_index(op.f('ix_tm_songs_album_id'), table_name='tm_songs')
    op.drop_table('tm_songs')
    op.drop_table('tm_biblioteca')
    op.drop_table('tm_usuario')
    op.drop_table('tm_grupo_permiso')
    op.drop_index(op.f('ix_tm_albums_name'), table_name='tm_albums')
    op.drop_table('tm_albums')
    op.drop_table('ts_tipo_archivo')
    op.drop_table('tm_permiso')
    op.drop_table('tm_grupo')
    op.drop_table('tm_colaborador')
    op.drop_index(op.f('ix_tm_artists_name'), table_name='tm_artists')
    op.drop_table('tm_artists')
    # ### end Alembic commands ###
    